﻿Imports System.Text
Imports System.Threading.Tasks

Namespace ODataSampleClient.Utilities
	''' <summary>
	''' Provide a source of several different useful pen colors.
	''' </summary>
	Public NotInheritable Class ColorPicker
		''' <summary>
		''' Initialize with a variety of colors.
		''' </summary>
		Private Shared colors() As SolidColorBrush = { Brushes.Aqua, Brushes.Azure, Brushes.Beige, Brushes.Blue, Brushes.Brown, Brushes.Chartreuse, Brushes.Coral, Brushes.CornflowerBlue, Brushes.Cyan, Brushes.DarkBlue, Brushes.DarkGreen, Brushes.DarkOrange, Brushes.DarkSalmon, Brushes.GreenYellow, Brushes.Indigo, Brushes.Lavender, Brushes.LemonChiffon, Brushes.LightBlue, Brushes.Maroon, Brushes.MediumBlue, Brushes.Orange, Brushes.PaleGreen, Brushes.Plum, Brushes.Red }

		''' <summary>
		''' Initialize at the start of the array.
		''' </summary>
'INSTANT VB NOTE: The variable nextColor was renamed since Visual Basic does not allow class members with the same name:
		Private Shared nextColor_Renamed As Integer = 0

		''' <summary>
		''' Get the next color in the array, cycling
		''' through the array when it is exhausted.
		''' </summary>
		''' <returns>The color selected</returns>
		Private Sub New()
		End Sub
		Public Shared ReadOnly Property NextColor() As SolidColorBrush
			Get
				' A return value.
				Dim result As SolidColorBrush = colors(nextColor_Renamed)

				' Cycle to the next color, wrapping after the end.
				nextColor_Renamed += 1
				If nextColor_Renamed >= colors.Length Then
					nextColor_Renamed = 0
				End If

				Return result
			End Get
		End Property

	End Class
End Namespace
